/* DAT.H */

/*        Categories database        */
/* M.Fleming, R.Gunther, R.Rosebrugh */
/* Mount Allison University 1994-95  */

#include	<stdlib.h>
#include <stdio.h>
#include	"read.h"
#define	MAXARR	50
#define MAXWORD 30

/* DATA TYPES */

typedef enum {inv_comp,dom_err,cod_err}
					err;

typedef	enum	{obj_dom,obj_cod,rel_err,fun_lhs,fun_rhs,fnc_arr_lhs,fnc_arr_rhs,X_obj,X_arr}
			data_e;


typedef struct	{
			int		lhs[MAXWORD],
					rhs[MAXWORD];
			}			relation;


typedef	struct	{
			char		name[MAXWORD];
			char		obj[MAXARR];		/*	array for object names 	*/
			int		arr[MAXARR][2];		/*	double array for arrows	*/
			char		arrow[MAXARR];		/*	arrow names		*/
			int		numobj,
					numarr,
					num_rel;
			relation	*rel_set;
			}			category;


typedef	struct	{
			char		name[MAXWORD];
			int		obj[MAXARR];
			int		arr[MAXARR][MAXWORD];
			}			cat_functor;


struct  category_node  {
			category	cat;
			struct category_node *next;
			int	saved;
			};


typedef	struct	{
			struct	category_node	*head;
			struct	category_node	*tail;
			}	category_list;


/* GLOBAL VARIABLES */

extern	category	A,B;
extern	int max_path;
extern	FILE *outf;

/* FUNCTIONS */

extern  void		clearscreen(void);
extern	void		data_error(data_e,char,char);
extern  category	init_cat(void);
extern  char	   	look_obj(category*,int);
extern  char*	   	look_name(category*);
extern  char*	   	look_arr(category*,int,char[7]);
extern  void	   	print_c(category*, FILE*);
extern	int			all_arr(category*,int,int[MAXARR]);
extern  int			all_arr_cod(category*, int, int[MAXARR]);
extern	category    init_rel(category*);
extern	void		print_rel(category,FILE*);
extern	void		initialize_cat_list(category_list*);
extern	void		add_category(category_list*,category);
extern	void 		remove_category(category_list*, struct category_node*);
extern	void		display_cat_list(category_list);
extern  struct category_node *find_category_name(category_list,char[MAXWORD]);
extern  struct category_node *find_category_number(category_list,int);
extern  int num_cat(category_list);
extern void	swap(category*);
extern void comp_check(category);
extern void error(err,char,char,int,char[5]);
extern bool check_obj(char, category);
extern bool check_arr(char, category);
extern bool check_string(char[],category);
extern bool check_path(int[],category);
extern bool equals(int[MAXWORD], int[MAXWORD]);
extern int	path_len(int[MAXWORD]);
extern void copy_path(int[MAXWORD], int[MAXWORD]);
extern void	copy_sub(int[MAXWORD], int[MAXWORD], int, int);
extern void append_path(int[MAXWORD], int[MAXWORD]);
extern bool greater(int[MAXWORD], int[MAXWORD]);
extern int search(int[MAXWORD], int[MAXWORD], int);
extern void reduce(int[MAXWORD], int[MAXWORD], category);
extern char* path_to_string(int[MAXWORD], category);
extern int object_number(char, category);
extern int arrow_number(char, category);
extern int* string_to_path(char[MAXWORD], category);
extern void make_dual(category,category_list);
extern void remove_obj(int,category*);
extern void remove_arr(int,category*);
extern bool arrow_in_path(int,int[MAXWORD]);
extern bool arrow_in_rel(int,category);
extern void	remove_rel(int,category*);
extern cat_functor init_sf(category);
extern void print_sf(cat_functor,FILE*,category);
extern void flush(void);