/*FUNCTOR.H*/

/*        Categories database        */
/* M.Fleming, R.Gunther, R.Rosebrugh */
/* Mount Allison University 1994-95  */

#include	"dat.h"

struct functor_node	{
			cat_functor f;
			struct functor_node *next;
			int saved;
			category A;
			category B;
			int functor_type;
			};

typedef struct {
			struct functor_node *head;
			struct functor_node *tail;
			} functor_list;


extern void get_functor_name(cat_functor*);
extern void get_functor_objects(cat_functor*,category,category);
extern bool check_domain(int[MAXWORD],int,cat_functor,category,category);
extern bool check_codomain(int[MAXWORD],int,cat_functor,category,category);
extern bool get_functor_arrows(cat_functor*,category,category);
extern bool check_functor_relations(struct functor_node);
extern bool check_sf_relations(struct functor_node);
extern void initialize_functor_list(functor_list*);
extern void add_functor(functor_list*, struct functor_node);
extern void remove_functor(functor_list*, struct functor_node*);
extern void print_functor(cat_functor, FILE*, category, category);
extern int display_functor_list(functor_list);
extern struct functor_node *find_functor_name(functor_list,char[MAXWORD]);
extern struct functor_node *find_functor_number(functor_list,int);
extern int num_functors(functor_list);
extern cat_functor init_functor(category, category);
extern struct functor_node load_functor(int);
extern void save_functor(struct functor_node);
extern struct functor_node make_functor_node(cat_functor,category,category);
extern void get_sf_name(cat_functor*);
extern void get_sf_objects(cat_functor*, category);
extern bool get_sf_arrows(cat_functor*, category);
extern int	function_value(int[MAXWORD],cat_functor,int);
extern void	functor_on_path(struct functor_node, int[MAXWORD], int[MAXWORD]);
extern int reverse_image_obj(struct functor_node, int, int[MAXWORD]);
extern void create_functor(category_list, functor_list*);
extern void create_sf(category_list, functor_list*);
extern void remove_func_proc(functor_list*);
extern void save_func_proc(functor_list);
extern void display_func_proc(functor_list);