/*RKAN.H*/

/*        Categories database        */
/* M.Fleming, R.Gunther, R.Rosebrugh */
/* Mount Allison University 1994-95  */

#include        "sum.h"


struct pointer_node  	{
			struct rkan_node *p;
			struct pointer_node *next;
			};

struct pointer_list	{
			struct pointer_node *head;
			struct pointer_node *tail;
			};

struct b_node   	{
			struct pointer_list  p_list;
			struct b_node *next;
			};

struct b_list	{
			struct b_node *head;
			struct b_node *tail;
			};

struct  rkan_node       {
			int     a_beta;
			struct b_list list;
			struct rkan_node *next;
			int valid;
			};

struct  rkan_list       {
			struct  rkan_node       *head;
			struct  rkan_node       *tail;
			struct  nodetype        *paths;
			struct  rkan_list *next;
			};

struct  big_list 	{
			struct rkan_list *head;
			struct rkan_list *tail;
			};

extern void go_through_betas(struct nodetype*,int[MAXWORD],int,int[MAXWORD],int[MAXWORD],struct functor_node*,struct nodetype*);
extern void get_all_arrows(int[MAXWORD],int,int[],struct functor_node*,int[MAXWORD],struct nodetype*,struct nodetype*,int);
void make_beta_arrows(struct nodetype*,struct functor_node*,struct nodetype*,int[MAXWORD],int);
extern void get_all_betas(struct nodetype*,int[MAXWORD],struct functor_node*,struct nodetype*, struct nodetype*,int);
extern void make_beta_objects(int[MAXWORD],int,int[MAXWORD],struct nodetype*,struct functor_node*,int);
extern void make_id_beta_object(int,struct nodetype*,struct functor_node*);
extern int display_Btree(struct nodetype*, int[MAXWORD], struct functor_node*,int,char);
extern void display_t(struct nodetype*, int[MAXWORD], struct functor_node*);
extern void eliminate_betas(int[], int, int[], struct functor_node*, int[MAXWORD], struct nodetype*, struct nodetype*,int);
extern void add_to_rkan_list(struct rkan_list*,int);
extern void add_to_big_list(struct big_list*, struct nodetype*, struct functor_node*);
extern void make_big_list(int[MAXWORD], struct nodetype*, struct big_list*, struct functor_node*);
extern void find_p1(int[MAXWORD], struct nodetype*, struct nodetype*, struct functor_node*,struct rkan_list*, struct rkan_list*);
extern void find_p2(int[MAXWORD], struct nodetype*, struct functor_node*, struct nodetype*, int[MAXWORD],struct rkan_list*, struct rkan_list*);
extern void assign_pointers(struct big_list*);
extern void check_pointers(struct big_list*,struct functor_node*);
extern void remove_pointer(struct rkan_node*, struct rkan_node*);
extern int find_RofB(struct rkan_node*,int[MAXWORD],int,int,struct nodetype*,struct big_list*,int,struct nodetype*[MAXWORD],int[MAXWORD],int,struct functor_node*,struct functor_node*,int);
extern int  num_betas(struct big_list*);
extern void free_big_list(struct big_list*);
extern void free_rkan_list(struct rkan_list*);
extern void free_rkan_node(struct rkan_node*);
extern void free_b_node(struct b_node*);
extern void test_self(int[MAXWORD], struct nodetype*, struct functor_node*, struct rkan_list*,struct big_list*,struct nodetype*);
extern void test_self2(int[MAXWORD], struct nodetype*, struct functor_node*, struct nodetype*, int[MAXWORD], struct rkan_list*,struct big_list*);
extern void remove_all_pointers(struct rkan_node*);
extern void remove_entire_node(struct rkan_node*, struct rkan_list*);
extern void pause_print(void);
extern void display_heading(int,char[MAXWORD],bool,struct functor_node*,char);
extern void display_heading2(int[MAXWORD],int,int[MAXARR],category,int,bool,bool[MAXWORD]);
extern void right_kan(category_list, functor_list,int);
extern struct category_node *get_cat(char,category_list);
extern struct functor_node *get_fun(functor_list,struct category_node*,struct category_node*);
extern struct functor_node *get_sf(functor_list,struct category_node*);
extern void display_images(struct nodetype*[MAXWORD],int,struct functor_node*,int[MAXWORD],int[MAXWORD],struct functor_node*,int);
extern void traverse_cod_tree(struct nodetype*,int[MAXWORD],struct functor_node*,struct nodetype*,int,int[MAXWORD],struct functor_node*,int);
extern int traverse_dom_tree(struct nodetype*,int[MAXWORD],struct functor_node*,int,int[MAXWORD],int[MAXWORD],int,bool*,int);
extern int alt_dom_tree(struct nodetype*,int[MAXWORD],struct functor_node *,struct functor_node*,int,int[MAXWORD],int,int[MAXWORD],int,bool*,int);
extern void find_path_from(int,int,int[MAXWORD],int[MAXWORD],struct functor_node*,int[MAXWORD],int,int[MAXWORD],bool*,int,int[MAXWORD]);
extern int display_RB_rho(struct rkan_node*,int[MAXWORD],int,int,struct nodetype*,struct big_list*,int,int[MAXWORD]);
extern int mod10(int);
extern bool check_zero(struct nodetype*, int[MAXWORD], struct functor_node*);
extern void make_rhoarr(struct nodetype*, int[MAXWORD],struct functor_node*,int, int*, char[MAXWORD], int[MAXWORD]);
