/*TREE.H*/

/*        Categories database        */
/* M.Fleming, R.Gunther, R.Rosebrugh */
/* Mount Allison University 1994-95  */

#include "confluen.h"

typedef	int	datatype;

struct listnodetype	{
		struct listnodetype *next;
		datatype data;
		};

struct nodetype	{
		struct nodetype	*down;
		struct nodetype	*across;
		datatype data;
		struct nodetype *tree;
		bool flag;
		int info;
		};

typedef struct listnodetype *listtype;

/*FUNCTIONS*/
extern struct nodetype* create_tree(void);
extern struct nodetype *add_node(struct nodetype*, datatype);
extern bool search_level(struct nodetype**, datatype);
extern bool search_tree(struct nodetype*, listtype, struct nodetype**);
extern bool search_and_add(struct nodetype*, listtype, struct nodetype**);
extern void make_list(listtype*, int[MAXWORD]);
extern void display_list(listtype);
extern void display_tree(struct nodetype*);
extern bool equal_trees(struct nodetype*, struct nodetype*);
extern void free_tree(struct nodetype*);
extern void free_list(struct listnodetype*);